Index: issm/trunk/configure.ac
===================================================================
--- issm/trunk/configure.ac	(revision 27035)
+++ issm/trunk/configure.ac	(revision 27232)
@@ -2,5 +2,5 @@
 
 #AUTOCONF
-AC_INIT([Ice-sheet and Sea-level System Model (ISSM)],[4.20],[issm@jpl.nasa.gov],[issm],[http://issm.jpl.nasa.gov]) #Initializing configure
+AC_INIT([Ice-sheet and Sea-level System Model (ISSM)],[4.21],[issm@jpl.nasa.gov],[issm],[http://issm.jpl.nasa.gov]) #Initializing configure
 AC_CONFIG_AUX_DIR([./aux-config])	# Put config files in aux-config
 AC_CONFIG_MACRO_DIR([m4])			# m4 macros are located in m4
Index: issm/trunk/etc/environment.sh
===================================================================
--- issm/trunk/etc/environment.sh	(revision 27035)
+++ issm/trunk/etc/environment.sh	(revision 27232)
@@ -299,4 +299,13 @@
 fi
 
+HDF5_ROOT="${ISSM_EXT_DIR}/hdf5/install"
+if [ -d "${HDF5_ROOT}" ]; then
+	export HDF5_ROOT # Used in installation of NetCDF, GDAL
+	cpath_append "${HDF5_ROOT}/include"
+	library_path_append "${HDF5_ROOT}/lib"
+	dyld_library_path_append "${HDF5_ROOT}/lib"
+	ld_library_path_append "${HDF5_ROOT}/lib"
+fi
+
 LAPACK_ROOT="${ISSM_EXT_DIR}/lapack/install"
 if [ -d "${LAPACK_ROOT}" ]; then
@@ -308,4 +317,8 @@
 		path_append "${LAPACK_ROOT}/lib" # Allows dynamic loader to find DLLs
 	fi
+
+	if ls ${LAPACK_ROOT}/lib/libblas.* 1> /dev/null 2>&1; then
+		export BLAS_ROOT="${LAPACK_ROOT}"
+	fi
 fi
 
@@ -340,4 +353,11 @@
 		path_append "${PARMETIS_ROOT}/lib" # Allows dynamic loader to find DLLs
 	fi
+fi
+
+QD_ROOT="${ISSM_EXT_DIR}/qd/install"
+if [ -d "${QD_ROOT}" ]; then
+	export QD_ROOT # Used in installation of MPLAPACK
+	library_path_prepend "${QD_ROOT}/lib"
+	ld_library_path_prepend "${QD_ROOT}/lib"
 fi
 
@@ -430,23 +450,4 @@
 ld_library_path_append "${TAO_ROOT}/lib"
 
-DAKOTA_ROOT="${ISSM_EXT_DIR}/dakota/install"
-if [ -d "${DAKOTA_ROOT}" ]; then
-	path_append "${DAKOTA_ROOT}/bin"
-	ld_library_path_append "${DAKOTA_ROOT}/lib"
-	dyld_library_path_prepend "${DAKOTA_ROOT}/lib"
-fi
-
-NCO_ROOT="${ISSM_EXT_DIR}/nco/install/bin"
-path_prepend "${NCO_ROOT}/bin"
-
-CPPCHECK_ROOT="${ISSM_EXT_DIR}/cppcheck/install"
-path_append "${CPPCHECK_ROOT}/bin"
-
-MERCURIAL_ROOT="${ISSM_EXT_DIR}/mercurial/install"
-if [ -d "${MERCURIAL_ROOT}" ]; then
-	export PYTHONPATH="${PYTHONPATH}:${MERCURIAL_ROOT}/mercurial/pure/"
-	path_append "${MERCURIAL_ROOT}"
-fi
-
 BOOST_ROOT="${ISSM_EXT_DIR}/boost/install"
 if [ -d "${BOOST_ROOT}" ]; then
@@ -454,8 +455,27 @@
 	export BOOST_DIR=${BOOST_ROOT}
 	export BOOSTROOT=${BOOST_ROOT}
-	library_path_append "${BOOST_ROOT}/lib"
-	ld_library_path_append "${BOOST_ROOT}/lib"
-	dyld_library_path_append "${BOOST_ROOT}/lib"
 	path_append "${BOOST_ROOT}/bin"
+	library_path_prepend "${BOOST_ROOT}/lib"
+	ld_library_path_prepend "${BOOST_ROOT}/lib"
+	dyld_library_path_prepend "${BOOST_ROOT}/lib"
+fi
+
+DAKOTA_ROOT="${ISSM_EXT_DIR}/dakota/install"
+if [ -d "${DAKOTA_ROOT}" ]; then
+	path_append "${DAKOTA_ROOT}/bin"
+	ld_library_path_prepend "${DAKOTA_ROOT}/lib"
+	dyld_library_path_prepend "${DAKOTA_ROOT}/lib"
+fi
+
+NCO_ROOT="${ISSM_EXT_DIR}/nco/install/bin"
+path_prepend "${NCO_ROOT}/bin"
+
+CPPCHECK_ROOT="${ISSM_EXT_DIR}/cppcheck/install"
+path_append "${CPPCHECK_ROOT}/bin"
+
+MERCURIAL_ROOT="${ISSM_EXT_DIR}/mercurial/install"
+if [ -d "${MERCURIAL_ROOT}" ]; then
+	export PYTHONPATH="${PYTHONPATH}:${MERCURIAL_ROOT}/mercurial/pure/"
+	path_append "${MERCURIAL_ROOT}"
 fi
 
@@ -469,9 +489,9 @@
 if [ -d "${NETCDF_ROOT}" ]; then
 	export NETCDF_ROOT # Used in installation of GDAL, GMT
-	path_append "${NETCDF_ROOT}/bin"
-	cpath_append "${NETCDF_ROOT}/include"
-	library_path_append "${NETCDF_ROOT}/lib"
-	dyld_library_path_append "${NETCDF_ROOT}/lib"
-	ld_library_path_append "${NETCDF_ROOT}/lib"
+	path_prepend "${NETCDF_ROOT}/bin"
+	cpath_prepend "${NETCDF_ROOT}/include"
+	library_path_prepend "${NETCDF_ROOT}/lib"
+	dyld_library_path_prepend "${NETCDF_ROOT}/lib"
+	ld_library_path_prepend "${NETCDF_ROOT}/lib"
 fi
 
@@ -491,16 +511,8 @@
 if [ -d "${CURL_ROOT}" ]; then
 	export CURL_ROOT # Used in installation of NetCDF, GDAL, GMT
-	ld_library_path_append "${CURL_ROOT}/lib"
-	dyld_library_path_append "${CURL_ROOT}/lib"
+	cpath_prepend "${CURL_ROOT}/include"
+	ld_library_path_prepend "${CURL_ROOT}/lib"
+	dyld_library_path_prepend "${CURL_ROOT}/lib"
 	path_append "${CURL_ROOT}/bin"
-fi
-
-HDF5_ROOT="${ISSM_EXT_DIR}/hdf5/install"
-if [ -d "${HDF5_ROOT}" ]; then
-	export HDF5_ROOT # Used in installation of NetCDF, GDAL
-	cpath_append "${HDF5_ROOT}/include"
-	library_path_append "${HDF5_ROOT}/lib"
-	dyld_library_path_append "${HDF5_ROOT}/lib"
-	ld_library_path_append "${HDF5_ROOT}/lib"
 fi
 
Index: issm/trunk/examples/Greenland/runme.m
===================================================================
--- issm/trunk/examples/Greenland/runme.m	(revision 27035)
+++ issm/trunk/examples/Greenland/runme.m	(revision 27232)
@@ -21,5 +21,5 @@
 
 	%Mesh Greenland
-	md=bamg(md,'hmax',400000,'hmin',5000,'gradation',1.7,'field',vel,'err',8);
+	md=bamg(md,'hmax',400000,'hmin',5000,'gradation',1.4,'field',vel,'err',8);
 
 	%convert x,y coordinates (Polar stereo) to lat/lon
@@ -56,5 +56,5 @@
 	md.inversion.cost_functions_coefficients=ones(md.mesh.numberofvertices,3);
 	md.inversion.cost_functions_coefficients(:,1)=350;
-	md.inversion.cost_functions_coefficients(:,2)=0.6;
+	md.inversion.cost_functions_coefficients(:,2)=0.2;
 	md.inversion.cost_functions_coefficients(:,3)=2e-6;
 
Index: issm/trunk/examples/Greenland/runme.py
===================================================================
--- issm/trunk/examples/Greenland/runme.py	(revision 27035)
+++ issm/trunk/examples/Greenland/runme.py	(revision 27232)
@@ -42,5 +42,5 @@
 
     #Mesh Greenland
-    md = bamg(md, 'hmax', 400000, 'hmin', 5000, 'gradation', 1.7, 'field', vel, 'err', 8)
+    md = bamg(md, 'hmax', 400000, 'hmin', 5000, 'gradation', 1.4, 'field', vel, 'err', 8)
 
     #convert x, y coordinates (Polar stereo) to lat / lon
@@ -77,5 +77,5 @@
     md.inversion.cost_functions_coefficients = np.ones((md.mesh.numberofvertices, 3))
     md.inversion.cost_functions_coefficients[:, 0] = 350
-    md.inversion.cost_functions_coefficients[:, 1] = 0.6
+    md.inversion.cost_functions_coefficients[:, 1] = 0.2
     md.inversion.cost_functions_coefficients[:, 2] = 2e-6
 
Index: issm/trunk/examples/Inversion/runme.m
===================================================================
--- issm/trunk/examples/Inversion/runme.m	(revision 27035)
+++ issm/trunk/examples/Inversion/runme.m	(revision 27232)
@@ -1,3 +1,3 @@
-steps=[4];
+steps=[1];
 
 if any(steps==1) 
Index: issm/trunk/examples/UncertaintyQuantification/runme.m
===================================================================
--- issm/trunk/examples/UncertaintyQuantification/runme.m	(revision 27035)
+++ issm/trunk/examples/UncertaintyQuantification/runme.m	(revision 27232)
@@ -5,4 +5,5 @@
 	disp('   Step 1: plot flux gates');
 
+	% NOTE: Need to run all steps of ../Pig/runme.m first!
 	md = loadmodel('../Pig/Models/PIG_Control_drag');
 
Index: issm/trunk/externalpackages/boost/install-1.7-mac.sh
===================================================================
--- issm/trunk/externalpackages/boost/install-1.7-mac.sh	(revision 27035)
+++ issm/trunk/externalpackages/boost/install-1.7-mac.sh	(revision 27232)
@@ -54,2 +54,10 @@
 	install_name_tool -id ${PREFIX}/lib/${name} ${name} 2>/dev/null
 done
+
+if [ "${VER}" == "1_79_0" ]; then
+	## Patch install names for certain libraries
+	#
+	# TODO: Figure out how to reconfigure source to apply these install names at compile time
+	#
+	install_name_tool -change @rpath/libboost_atomic.dylib ${PREFIX}/lib/libboost_atomic.dylib libboost_filesystem.dylib
+fi
Index: issm/trunk/externalpackages/chaco/install.sh
===================================================================
--- issm/trunk/externalpackages/chaco/install.sh	(revision 27035)
+++ issm/trunk/externalpackages/chaco/install.sh	(revision 27232)
@@ -8,4 +8,8 @@
 
 PREFIX="${ISSM_DIR}/externalpackages/chaco/install" # Set to location where external package should be installed
+
+## Environment
+#
+export CFLAGS="-Wno-error=implicit-function-declaration"
 
 # Cleanup
Index: issm/trunk/externalpackages/curl/install-7-linux-static.sh
===================================================================
--- issm/trunk/externalpackages/curl/install-7-linux-static.sh	(revision 27035)
+++ issm/trunk/externalpackages/curl/install-7-linux-static.sh	(revision 27232)
@@ -34,4 +34,5 @@
 	--disable-ldaps \
 	--with-zlib="${ZLIB_ROOT}" \
+	--without-zstd \
 	--without-libidn2 \
 	--without-nghttp2 \
Index: issm/trunk/externalpackages/curl/install-7-mac-static.sh
===================================================================
--- issm/trunk/externalpackages/curl/install-7-mac-static.sh	(revision 27035)
+++ issm/trunk/externalpackages/curl/install-7-mac-static.sh	(revision 27232)
@@ -38,4 +38,5 @@
 	--disable-ldaps \
 	--with-zlib="${ZLIB_ROOT}" \
+	--without-zstd \
 	--without-libidn2 \
 	--without-nghttp2 \
Index: issm/trunk/externalpackages/dakota/install-6.2-linux-static.sh
===================================================================
--- issm/trunk/externalpackages/dakota/install-6.2-linux-static.sh	(revision 27035)
+++ issm/trunk/externalpackages/dakota/install-6.2-linux-static.sh	(revision 27232)
@@ -9,12 +9,20 @@
 PREFIX="${ISSM_DIR}/externalpackages/dakota/install" # Set to location where external package should be installed
 
+# Find libgfortran and libgcc so we do not have to hardcode them
+#
+# TODO:
+# - Move this to etc/environment.sh
+#
+LIBGFORTRAN=$(find /usr -name libgfortran* | egrep -n libgfortran.a | sed "s/[0-9]*://g" | head -1)
+LIBGFORTRAN_ROOT=${LIBGFORTRAN%/*}
+LIBGCC=$(find ${LIBGFORTRAN_ROOT} -name libgcc* | egrep -n libgcc.a | sed "s/[0-9]*://g" | head -1
+
 ## Environment
 #
-export BLAS_LIBS="-L${BLAS_ROOT}/lib -lfblas -L/usr/lib/x86_64-linux-gnu -lgfortran" # Need to export BLAS_LIBS *and* pass it as an option to CMake to ensure that external packages also find it
-export CXXFLAGS='-std=c++98' # Setting CXXFLAGS to deal with C++11 incompatibility with MATLAB's Boost (absolutely necessary for this version)
+export BLAS_LIBS="-L${BLAS_ROOT}/lib -lfblas ${LIBGFORTRAN_ROOT}/libgfortran.a ${LIBGFORTRAN_ROOT}/libquadmath.a ${LIBGCC}" # Need to export BLAS_LIBS *and* pass it as an option to CMake to ensure that external packages also find it
 export DAK_BUILD=${ISSM_DIR}/externalpackages/dakota/build # DO NOT CHANGE THIS
 export DAK_INSTALL=${PREFIX} # DO NOT CHANGE THIS
 export DAK_SRC=${ISSM_DIR}/externalpackages/dakota/src # DO NOT CHANGE THIS
-export LAPACK_LIBS="-L${LAPACK_ROOT}/lib -lflapack -L/usr/lib/x86_64-linux-gnu -lgfortran" # Need to export LAPACK_LIBS *and* pass it as an option to CMake to ensure that external packages also find it
+export LAPACK_LIBS="-L${LAPACK_ROOT}/lib -lflapack -L/usr/lib/x86_64-linux-gnu ${LIBGFORTRAN_ROOT}/libgfortran.a ${LIBGFORTRAN_ROOT}/libquadmath.a ${LIBGCC}" # Need to export LAPACK_LIBS *and* pass it as an option to CMake to ensure that external packages also find it
 
 # Cleanup
@@ -45,4 +53,7 @@
 cp configs/${VER}/linux/cmake/DakotaDev.cmake ${DAK_SRC}/cmake
 
+# Disable requirement of Python 2 for TriBITS
+sed -i'' -e 's|SET(PythonInterp_FIND_VERSION|#SET(PythonInterp_FIND_VERSION|' ${DAK_SRC}/packages/teuchos/cmake/tribits/package_arch/TribitsFindPythonInterp.cmake
+
 # Configure
 cd ${DAK_BUILD}
@@ -54,4 +65,5 @@
 	-DCMAKE_CXX_COMPILER=${MPI_HOME}/bin/mpicxx \
 	-DCMAKE_CXX_FLAGS="-fPIC" \
+	-DCMAKE_CXX_STANDARD="11" \
 	-DCMAKE_Fortran_COMPILER=${MPI_HOME}/bin/mpif77 \
 	-DBoost_NO_BOOST_CMAKE=TRUE \
Index: issm/trunk/externalpackages/dakota/install-6.2-linux.sh
===================================================================
--- issm/trunk/externalpackages/dakota/install-6.2-linux.sh	(revision 27035)
+++ issm/trunk/externalpackages/dakota/install-6.2-linux.sh	(revision 27232)
@@ -12,6 +12,4 @@
 #
 export BLAS_LIBS="-L${BLAS_ROOT}/lib -lfblas -L/usr/lib/x86_64-linux-gnu -lgfortran" # Need to export BLAS_LIBS *and* pass it as an option to CMake to ensure that external packages also find it
-export CXXFLAGS='-std=c++98' # Setting CXXFLAGS to deal with C++11 incompatibility with MATLAB's Boost (absolutely necessary for this version)
-#export CXXFLAGS='-std=c++11'
 export DAK_BUILD=${ISSM_DIR}/externalpackages/dakota/build # DO NOT CHANGE THIS
 export DAK_INSTALL=${PREFIX} # DO NOT CHANGE THIS
@@ -46,4 +44,7 @@
 cp configs/${VER}/linux/cmake/DakotaDev.cmake ${DAK_SRC}/cmake
 
+# Disable requirement of Python 2 for TriBITS
+sed -i'' -e 's|SET(PythonInterp_FIND_VERSION|#SET(PythonInterp_FIND_VERSION|' ${DAK_SRC}/packages/teuchos/cmake/tribits/package_arch/TribitsFindPythonInterp.cmake
+
 # Configure
 cd ${DAK_BUILD}
@@ -54,4 +55,5 @@
 	-DCMAKE_C_FLAGS="-Wno-error=implicit-function-declaration" \
 	-DCMAKE_CXX_COMPILER=${MPI_HOME}/bin/mpicxx \
+	-DCMAKE_CXX_STANDARD="11" \
 	-DCMAKE_Fortran_COMPILER=${MPI_HOME}/bin/mpif77 \
 	-DBoost_NO_BOOST_CMAKE=TRUE \
Index: issm/trunk/externalpackages/dakota/install-6.2-mac-static.sh
===================================================================
--- issm/trunk/externalpackages/dakota/install-6.2-mac-static.sh	(revision 27035)
+++ issm/trunk/externalpackages/dakota/install-6.2-mac-static.sh	(revision 27232)
@@ -8,7 +8,4 @@
 
 PREFIX="${ISSM_DIR}/externalpackages/dakota/install" # Set to location where external package should be installed
-
-## Environment
-#
 
 # Find libgfortran and libgcc so we do not have to hardcode them.
@@ -22,8 +19,10 @@
 # - Otherwise, refactor this to work with other gfortran installations
 #
-LIBGFORTRAN=$(mdfind -onlyin /usr -name libgfortran | grep -n libgfortran.a | grep -v i386 | sed "s/[0-9]*://g" | head -1)
+LIBGFORTRAN=$(mdfind -onlyin /usr -name libgfortran | egrep -n libgfortran.a | egrep -v i386 | sed "s/[0-9]*://g" | head -1)
 LIBGFORTRAN_ROOT=${LIBGFORTRAN%/*}
-LIBGCC=$(mdfind -onlyin ${LIBGFORTRAN_ROOT} -name libgcc | grep -n libgcc.a | grep -v i386 | sed "s/[0-9]*://g" | head -1)
+LIBGCC=$(mdfind -onlyin ${LIBGFORTRAN_ROOT} -name libgcc | egrep -n libgcc.a | egrep -v i386 | sed "s/[0-9]*://g" | head -1)
 
+## Environment
+#
 export BLAS_LIBS="-L${BLAS_ROOT}/lib -lfblas ${LIBGFORTRAN_ROOT}/libgfortran.a ${LIBGFORTRAN_ROOT}/libquadmath.a ${LIBGCC}" # Need to export BLAS_LIBS *and* pass it as an option to CMake to ensure that external packages also find it
 export DAK_BUILD=${ISSM_DIR}/externalpackages/dakota/build # DO NOT CHANGE THIS
@@ -72,4 +71,7 @@
 # cp configs/${VER}/mac/static/packages/nidr/nidr-scanner.c ${DAK_SRC}/packages/nidr
 
+# Disable requirement of Python 2 for TriBITS
+sed -i'' -e 's|SET(PythonInterp_FIND_VERSION|#SET(PythonInterp_FIND_VERSION|' ${DAK_SRC}/packages/teuchos/cmake/tribits/package_arch/TribitsFindPythonInterp.cmake
+
 # Configure
 cd ${DAK_BUILD}
@@ -81,4 +83,5 @@
 	-DCMAKE_CXX_COMPILER=${MPI_HOME}/bin/mpicxx \
 	-DCMAKE_CXX_FLAGS="-fPIC -fdelayed-template-parsing" \
+	-DCMAKE_CXX_STANDARD="11" \
 	-DCMAKE_Fortran_COMPILER=${MPI_HOME}/bin/mpif77 \
 	-DCMAKE_Fortran_FLAGS="-fPIC -fallow-argument-mismatch" \
Index: issm/trunk/externalpackages/dakota/install-6.2-mac.sh
===================================================================
--- issm/trunk/externalpackages/dakota/install-6.2-mac.sh	(revision 27035)
+++ issm/trunk/externalpackages/dakota/install-6.2-mac.sh	(revision 27232)
@@ -9,7 +9,4 @@
 PREFIX="${ISSM_DIR}/externalpackages/dakota/install" # Set to location where external package should be installed
 
-## Environment
-#
-
 # Find libgfortran so that we do not have to hardcode it.
 #
@@ -20,7 +17,9 @@
 # - Move this to etc/environment.sh
 #
-LIBGFORTRAN=$(mdfind -onlyin /usr -name libgfortran | grep -n libgfortran.a | grep -v i386 | sed "s/[0-9]*://g" | head -1)
+LIBGFORTRAN=$(mdfind -onlyin /usr -name libgfortran | egrep -n libgfortran.a | egrep -v i386 | sed "s/[0-9]*://g" | head -1)
 LIBGFORTRAN_ROOT=${LIBGFORTRAN%/*}
 
+## Environment
+#
 export BLAS_LIBS="-L${BLAS_ROOT}/lib -lfblas -L${LIBGFORTRAN_ROOT} -lgfortran" # Need to export BLAS_LIBS *and* pass it as an option to CMake to ensure that external packages also find it
 export DAK_BUILD=${ISSM_DIR}/externalpackages/dakota/build # DO NOT CHANGE THIS
@@ -57,4 +56,7 @@
 cp configs/${VER}/mac/cmake/InstallDarwinDylibs.cmake ${DAK_SRC}/cmake
 
+# Disable requirement of Python 2 for TriBITS
+sed -i'' -e 's|SET(PythonInterp_FIND_VERSION|#SET(PythonInterp_FIND_VERSION|' ${DAK_SRC}/packages/teuchos/cmake/tribits/package_arch/TribitsFindPythonInterp.cmake
+
 # Configure
 cd ${DAK_BUILD}
@@ -65,6 +67,6 @@
 	-DCMAKE_CXX_COMPILER=${MPI_HOME}/bin/mpicxx \
 	-DCMAKE_CXX_FLAGS="-fdelayed-template-parsing" \
+	-DCMAKE_CXX_STANDARD="11" \
 	-DCMAKE_Fortran_COMPILER=${MPI_HOME}/bin/mpif77 \
-	-DCMAKE_Fortran_FLAGS="-fallow-argument-mismatch" \
 	-DBoost_NO_BOOST_CMAKE=TRUE \
 	-DHAVE_ACRO=OFF \
Index: issm/trunk/externalpackages/gdal/install-3-python-static.sh
===================================================================
--- issm/trunk/externalpackages/gdal/install-3-python-static.sh	(revision 27035)
+++ issm/trunk/externalpackages/gdal/install-3-python-static.sh	(revision 27232)
@@ -9,5 +9,5 @@
 ## Constants
 #
-VER="3.1.1"
+VER="3.5.1"
 
 ## Environment
@@ -42,10 +42,15 @@
 	--enable-static \
 	--with-pic \
-	--with-python \
+	--with-python=python3 \
+	--with-curl="${CURL_ROOT}/bin/curl-config" \
+	--with-hdf5="${HDF5_ROOT}" \
+	--with-jpeg=internal \
 	--with-libz="${ZLIB_ROOT}" \
-	--with-hdf5="${HDF5_ROOT}" \
 	--with-netcdf="${NETCDF_ROOT}" \
+	--with-pcre=no \
+	--with-pg=no \
+	--with-png=internal \
 	--with-proj="${PROJ_ROOT}" \
-	--with-pg=no
+	--with-zstd=no
 
 # Compile and install
Index: issm/trunk/externalpackages/gdal/install-3-python.sh
===================================================================
--- issm/trunk/externalpackages/gdal/install-3-python.sh	(revision 27035)
+++ issm/trunk/externalpackages/gdal/install-3-python.sh	(revision 27232)
@@ -9,5 +9,5 @@
 ## Constants
 #
-VER="3.1.1"
+VER="3.5.1"
 
 ## Environment
@@ -34,7 +34,7 @@
 	--prefix="${PREFIX}" \
 	--enable-fast-install \
-	--with-python \
+	--with-python=python3 \
+	--with-hdf5="${HDF5_ROOT}" \
 	--with-libz="${ZLIB_ROOT}" \
-	--with-hdf5="${HDF5_ROOT}" \
 	--with-netcdf="${NETCDF_ROOT}" \
 	--with-proj="${PROJ_ROOT}"
Index: issm/trunk/externalpackages/gdal/install-3-static.sh
===================================================================
--- issm/trunk/externalpackages/gdal/install-3-static.sh	(revision 27035)
+++ issm/trunk/externalpackages/gdal/install-3-static.sh	(revision 27232)
@@ -9,5 +9,5 @@
 ## Constants
 #
-VER="3.1.1"
+VER="3.5.1"
 
 ## Environment
@@ -42,9 +42,14 @@
 	--enable-static \
 	--with-pic \
+	--with-curl="${CURL_ROOT}/bin/curl-config" \
+	--with-hdf5="${HDF5_ROOT}" \
+	--with-jpeg=internal \
 	--with-libz="${ZLIB_ROOT}" \
-	--with-hdf5="${HDF5_ROOT}" \
 	--with-netcdf="${NETCDF_ROOT}" \
+	--with-pcre=no \
+	--with-pg=no \
+	--with-png=internal \
 	--with-proj="${PROJ_ROOT}" \
-	--with-pg=no
+	--with-zstd=no
 
 # Compile and install
Index: issm/trunk/externalpackages/gdal/install-3.sh
===================================================================
--- issm/trunk/externalpackages/gdal/install-3.sh	(revision 27035)
+++ issm/trunk/externalpackages/gdal/install-3.sh	(revision 27232)
@@ -5,5 +5,5 @@
 ## Constants
 #
-VER="3.1.1"
+VER="3.5.1"
 
 ## Environment
@@ -30,6 +30,6 @@
 	--prefix="${PREFIX}" \
 	--enable-fast-install \
+	--with-hdf5="${HDF5_ROOT}" \
 	--with-libz="${ZLIB_ROOT}" \
-	--with-hdf5="${HDF5_ROOT}" \
 	--with-netcdf="${NETCDF_ROOT}" \
 	--with-proj="${PROJ_ROOT}"
Index: issm/trunk/externalpackages/gmsh/install-4-linux-static.sh
===================================================================
--- issm/trunk/externalpackages/gmsh/install-4-linux-static.sh	(revision 27232)
+++ issm/trunk/externalpackages/gmsh/install-4-linux-static.sh	(revision 27232)
@@ -0,0 +1,83 @@
+#!/bin/bash
+set -eu
+
+
+# TODO:
+# - Add support for,
+#	- MUMPS
+#	- PETSc
+# 
+# See Also:
+# - configs/4/static/CMakeLists.txt
+# - http://gmsh.info/doc/texinfo/gmsh.html#Compiling-the-source-code
+#
+
+## Constants
+#
+VER="4.10.5"
+
+PREFIX="${ISSM_DIR}/externalpackages/gmsh/install" # Set to location where external package should be installed
+
+# Find libgfortran and libgcc so we do not have to hardcode them
+#
+# TODO:
+# - Move this to etc/environment.sh
+#
+LIBGFORTRAN=$(find /usr -name libgfortran* | egrep -n libgfortran.a | sed "s/[0-9]*://g" | head -1)
+LIBGFORTRAN_ROOT=${LIBGFORTRAN%/*}
+LIBGCC=$(find ${LIBGFORTRAN_ROOT} -name libgcc* | egrep -n libgcc.a | sed "s/[0-9]*://g" | head -1)
+
+# Cleanup
+rm -rf ${PREFIX} src
+mkdir -p ${PREFIX} src
+
+# Download source
+$ISSM_DIR/scripts/DownloadExternalPackage.sh "https://issm.ess.uci.edu/files/externalpackages/gmsh-${VER}-source.tgz" "gmsh-${VER}-source.tgz"
+
+# Unpack source
+tar -xvzf gmsh-${VER}-source.tgz
+
+# Move source to 'src' directory
+mv gmsh-${VER}-source/* src
+rm -rf gmsh-${VER}-source
+
+# Configure
+#
+# NOTE:
+# - Option -DENABLE_FLTK=0 is used because we do not need GUI.
+# - Option -DENABLE_MPEG_ENCODE=0 is used because we do not need to record MPEG 
+#	movies.
+# - Option -DENABLE_OCC=0 is used because we do not need CAD kernel and are not 
+#	importing STEP/IGES files.
+# - Option -DENABLE_TOUCHBAR=0 is used because we do not have GUI, therefore we 
+#	do not need to support Apple Touch bar (does not affect compilation on 
+#	Linux).
+#
+cd src
+cmake \
+	-DCMAKE_INSTALL_PREFIX="${PREFIX}" \
+	-DENABLE_BUILD_LIB=1 \
+	-DBLAS_LAPACK_LIBRARIES="-L${LAPACK_ROOT}/lib -lflapack -L${BLAS_ROOT}/lib -lfblas ${LIBGFORTRAN_ROOT}/libgfortran.a ${LIBGFORTRAN_ROOT}/libquadmath.a ${LIBGCC}" \
+	-DENABLE_BLAS_LAPACK=1 \
+	-DENABLE_EIGEN=0 \
+	-DENABLE_FLTK=0 \
+	-DENABLE_MPEG_ENCODE=0 \
+	-DENABLE_MPI=1 \
+	-DENABLE_OCC=0 \
+	-DENABLE_TOUCHBAR=0 \
+	-DMETIS_ROOT="${METIS_ROOT}"
+
+# Compile and install
+if [ $# -eq 0 ]; then
+	make
+	make install
+else
+	make -j $1
+	make -j $1 install
+fi
+
+# Make necessary link on RHEL
+if [[ -d ${PREFIX}/lib64 && ! -d ${PREFIX}/lib ]]; then
+	cd ${PREFIX}
+	ln -s ./lib64 ./lib
+fi
Index: issm/trunk/externalpackages/gmsh/install-4-linux.sh
===================================================================
--- issm/trunk/externalpackages/gmsh/install-4-linux.sh	(revision 27232)
+++ issm/trunk/externalpackages/gmsh/install-4-linux.sh	(revision 27232)
@@ -0,0 +1,83 @@
+#!/bin/bash
+set -eu
+
+
+# TODO:
+# - Add support for,
+#	- MUMPS
+#	- PETSc
+# 
+# See Also:
+# - configs/4/static/CMakeLists.txt
+# - http://gmsh.info/doc/texinfo/gmsh.html#Compiling-the-source-code
+#
+
+## Constants
+#
+VER="4.10.5"
+
+PREFIX="${ISSM_DIR}/externalpackages/gmsh/install" # Set to location where external package should be installed
+
+# Find libgfortran so that we do not have to hardcode it.
+#
+# TODO:
+# - Move this to etc/environment.sh
+#
+LIBGFORTRAN=$(find /usr -name libgfortran* | egrep -n libgfortran.a | sed "s/[0-9]*://g" | head -1)
+LIBGFORTRAN_ROOT=${LIBGFORTRAN%/*}
+
+# Cleanup
+rm -rf ${PREFIX} src
+mkdir -p ${PREFIX} src
+
+# Download source
+$ISSM_DIR/scripts/DownloadExternalPackage.sh "https://issm.ess.uci.edu/files/externalpackages/gmsh-${VER}-source.tgz" "gmsh-${VER}-source.tgz"
+
+# Unpack source
+tar -xvzf gmsh-${VER}-source.tgz
+
+# Move source to 'src' directory
+mv gmsh-${VER}-source/* src
+rm -rf gmsh-${VER}-source
+
+# Configure
+#
+# NOTE:
+# - Option -DENABLE_FLTK=0 is used because we do not need GUI.
+# - Option -DENABLE_MPEG_ENCODE=0 is used because we do not need to record MPEG 
+#	movies.
+# - Option -DENABLE_OCC=0 is used because we do not need CAD kernel and are not 
+#	importing STEP/IGES files.
+# - Option -DENABLE_TOUCHBAR=0 is used because we do not have GUI, therefore we 
+#	do not need to support Apple Touch bar (does not affect compilation on 
+#	Linux).
+#
+cd src
+cmake \
+	-DCMAKE_INSTALL_PREFIX="${PREFIX}" \
+	-DENABLE_BUILD_DYNAMIC=1 \
+	-DENABLE_BUILD_SHARED=1 \
+	-DBLAS_LAPACK_LIBRARIES="-L${LAPACK_ROOT}/lib -lflapack -L${BLAS_ROOT}/lib -lfblas -L${LIBGFORTRAN_ROOT} -lgfortran" \
+	-DENABLE_BLAS_LAPACK=1 \
+	-DENABLE_EIGEN=0 \
+	-DENABLE_FLTK=0 \
+	-DENABLE_MPEG_ENCODE=0 \
+	-DENABLE_MPI=1 \
+	-DENABLE_OCC=0 \
+	-DENABLE_TOUCHBAR=0 \
+	-DMETIS_ROOT="${METIS_ROOT}"
+
+# Compile and install
+if [ $# -eq 0 ]; then
+	make
+	make install
+else
+	make -j $1
+	make -j $1 install
+fi
+
+# Make necessary link on RHEL
+if [[ -d ${PREFIX}/lib64 && ! -d ${PREFIX}/lib ]]; then
+	cd ${PREFIX}
+	ln -s ./lib64 ./lib
+fi
Index: issm/trunk/externalpackages/gmsh/install-4-mac-static.sh
===================================================================
--- issm/trunk/externalpackages/gmsh/install-4-mac-static.sh	(revision 27232)
+++ issm/trunk/externalpackages/gmsh/install-4-mac-static.sh	(revision 27232)
@@ -0,0 +1,91 @@
+#!/bin/bash
+set -eu
+
+
+# TODO:
+# - Add support for,
+#	- MUMPS
+#	- PETSc
+# 
+# See Also:
+# - configs/4/static/CMakeLists.txt
+# - http://gmsh.info/doc/texinfo/gmsh.html#Compiling-the-source-code
+#
+
+## Constants
+#
+VER="4.10.5"
+
+PREFIX="${ISSM_DIR}/externalpackages/gmsh/install" # Set to location where external package should be installed
+
+
+# Find libgfortran and libgcc so we do not have to hardcode them
+#
+# Should retrieve a copy of gfortran that is compiled from source before returning one that is installed via package manager
+#
+# TODO:
+# - Move this to etc/environment.sh
+# - Test if -static-libgfortran flag will avoid all of this.
+# - Otherwise, refactor this to work with other gfortran installations.
+#
+LIBGFORTRAN=$(mdfind -onlyin /usr -name libgfortran | egrep -n libgfortran.a | egrep -v i386 | sed "s/[0-9]*://g" | head -1)
+LIBGFORTRAN_ROOT=${LIBGFORTRAN%/*}
+LIBGCC=$(mdfind -onlyin ${LIBGFORTRAN_ROOT} -name libgcc | egrep -n libgcc.a | egrep -v i386 | sed "s/[0-9]*://g" | head -1)
+
+# Cleanup
+rm -rf ${PREFIX} src
+mkdir -p ${PREFIX} src
+
+# Download source
+$ISSM_DIR/scripts/DownloadExternalPackage.sh "https://issm.ess.uci.edu/files/externalpackages/gmsh-${VER}-source.tgz" "gmsh-${VER}-source.tgz"
+
+# Unpack source
+tar -xvzf gmsh-${VER}-source.tgz
+
+# Move source to 'src' directory
+mv gmsh-${VER}-source/* src
+rm -rf gmsh-${VER}-source
+
+# Copy customized source and config files to 'src' directory
+cp configs/${VER}/static/CMakeLists.txt src
+
+# Configure
+#
+# NOTE:
+# - Option -DENABLE_FLTK=0 is used because we do not need GUI.
+# - Option -DENABLE_MPEG_ENCODE=0 is used because we do not need to record MPEG 
+#	movies.
+# - Option -DENABLE_OCC=0 is used because we do not need CAD kernel and are not 
+#	importing STEP/IGES files.
+# - Option -DENABLE_TOUCHBAR=0 is used because we do not have GUI, therefore we 
+#	do not need to support Apple Touch bar (does not affect compilation on 
+#	Linux).
+#
+cd src
+cmake \
+	-DCMAKE_INSTALL_PREFIX="${PREFIX}" \
+	-DENABLE_BUILD_LIB=1 \
+	-DBLAS_LAPACK_LIBRARIES="-L${LAPACK_ROOT}/lib -lflapack -L${BLAS_ROOT}/lib -lfblas ${LIBGFORTRAN_ROOT}/libgfortran.a ${LIBGFORTRAN_ROOT}/libquadmath.a ${LIBGCC}" \
+	-DENABLE_BLAS_LAPACK=1 \
+	-DENABLE_EIGEN=0 \
+	-DENABLE_FLTK=0 \
+	-DENABLE_MPEG_ENCODE=0 \
+	-DENABLE_MPI=1 \
+	-DENABLE_OCC=0 \
+	-DENABLE_TOUCHBAR=0 \
+	-DMETIS_ROOT="${METIS_ROOT}"
+
+# Compile and install
+if [ $# -eq 0 ]; then
+	make
+	make install
+else
+	make -j $1
+	make -j $1 install
+fi
+
+# Make necessary link on RHEL
+if [[ -d ${PREFIX}/lib64 && ! -d ${PREFIX}/lib ]]; then
+	cd ${PREFIX}
+	ln -s ./lib64 ./lib
+fi
Index: issm/trunk/externalpackages/gmsh/install-4-mac.sh
===================================================================
--- issm/trunk/externalpackages/gmsh/install-4-mac.sh	(revision 27232)
+++ issm/trunk/externalpackages/gmsh/install-4-mac.sh	(revision 27232)
@@ -0,0 +1,86 @@
+#!/bin/bash
+set -eu
+
+
+# TODO:
+# - Add support for,
+#	- MUMPS
+#	- PETSc
+# 
+# See Also:
+# - configs/4/static/CMakeLists.txt
+# - http://gmsh.info/doc/texinfo/gmsh.html#Compiling-the-source-code
+#
+
+## Constants
+#
+VER="4.10.5"
+
+PREFIX="${ISSM_DIR}/externalpackages/gmsh/install" # Set to location where external package should be installed
+
+# Find libgfortran so that we do not have to hardcode it.
+#
+# Should retrieve a copy of gfortran that is compiled from source before 
+# returning one that is installed via package manager.
+#
+# TODO:
+# - Move this to etc/environment.sh
+#
+LIBGFORTRAN=$(mdfind -onlyin /usr -name libgfortran | egrep -n libgfortran.a | egrep -v i386 | sed "s/[0-9]*://g" | head -1)
+LIBGFORTRAN_ROOT=${LIBGFORTRAN%/*}
+
+# Cleanup
+rm -rf ${PREFIX} src
+mkdir -p ${PREFIX} src
+
+# Download source
+$ISSM_DIR/scripts/DownloadExternalPackage.sh "https://issm.ess.uci.edu/files/externalpackages/gmsh-${VER}-source.tgz" "gmsh-${VER}-source.tgz"
+
+# Unpack source
+tar -xvzf gmsh-${VER}-source.tgz
+
+# Move source to 'src' directory
+mv gmsh-${VER}-source/* src
+rm -rf gmsh-${VER}-source
+
+# Configure
+#
+# NOTE:
+# - Option -DENABLE_FLTK=0 is used because we do not need GUI.
+# - Option -DENABLE_MPEG_ENCODE=0 is used because we do not need to record MPEG 
+#	movies.
+# - Option -DENABLE_OCC=0 is used because we do not need CAD kernel and are not 
+#	importing STEP/IGES files.
+# - Option -DENABLE_TOUCHBAR=0 is used because we do not have GUI, therefore we 
+#	do not need to support Apple Touch bar (does not affect compilation on 
+#	Linux).
+#
+cd src
+cmake \
+	-DCMAKE_INSTALL_PREFIX="${PREFIX}" \
+	-DENABLE_BUILD_DYNAMIC=1 \
+	-DENABLE_BUILD_SHARED=1 \
+	-DBLAS_LAPACK_LIBRARIES="-L${LAPACK_ROOT}/lib -lflapack -L${BLAS_ROOT}/lib -lfblas -L${LIBGFORTRAN_ROOT} -lgfortran" \
+	-DENABLE_BLAS_LAPACK=1 \
+	-DENABLE_EIGEN=0 \
+	-DENABLE_FLTK=0 \
+	-DENABLE_MPEG_ENCODE=0 \
+	-DENABLE_MPI=1 \
+	-DENABLE_OCC=0 \
+	-DENABLE_TOUCHBAR=0 \
+	-DMETIS_ROOT="${METIS_ROOT}"
+
+# Compile and install
+if [ $# -eq 0 ]; then
+	make
+	make install
+else
+	make -j $1
+	make -j $1 install
+fi
+
+# Make necessary link on RHEL
+if [[ -d ${PREFIX}/lib64 && ! -d ${PREFIX}/lib ]]; then
+	cd ${PREFIX}
+	ln -s ./lib64 ./lib
+fi
Index: issm/trunk/externalpackages/gmt/configs/6/static/cmake/modules/FindGDAL.cmake
===================================================================
--- issm/trunk/externalpackages/gmt/configs/6/static/cmake/modules/FindGDAL.cmake	(revision 27035)
+++ issm/trunk/externalpackages/gmt/configs/6/static/cmake/modules/FindGDAL.cmake	(revision 27232)
@@ -148,4 +148,6 @@
 		NAMES ${_extralib}
 		HINTS
+		${NETCDF_ROOT}
+		$ENV{NETCDF_ROOT}
 		${HDF5_ROOT}
 		$ENV{HDF5_ROOT}
Index: issm/trunk/externalpackages/gmt/configs/6/static/cmake/modules/FindNETCDF.cmake
===================================================================
--- issm/trunk/externalpackages/gmt/configs/6/static/cmake/modules/FindNETCDF.cmake	(revision 27035)
+++ issm/trunk/externalpackages/gmt/configs/6/static/cmake/modules/FindNETCDF.cmake	(revision 27232)
@@ -130,5 +130,5 @@
 # find all manually-supplied libs
 if (NETCDF_EXTRA_LIBS)
-	# Ensure -l is precedeced by whitespace to not match
+	# Ensure -l is preceded by whitespace to not match
 	# '-l' in '-L/usr/lib/x86_64-linux-gnu/hdf5/serial'
 	string (REGEX MATCHALL "(^| )-l[^ ]+" _netcdf_extra_lib_dashl ${NETCDF_EXTRA_LIBS})
